/* Copyright (C) 2009 Pierre Nicolas
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef _FBVAR_H_
#define _FBVAR_H_

#include "params.h"

#include <fstream>

#include <gsl/gsl_rng.h>
#include <string>
#include <vector>

using namespace std;

class FbVar
{

 public:
  int _nS;
  int _nR;
  int _windowl;

  //Forward-Backward
  float*** _pforw1; //_pforw1[t+1][q][v] P(S_t+1=v, R_t=q | X_1^t) 
  float*** _pforw2; //_pforw2[t+1][q][v] P(S_t+1=v, R_t=q | X_1^{t+1}) 
  float*** _pforw3; //_pforw3[t+1][q][v] P(S_t+1=v, R_t+1=q | X_1^{t+1})
  float*** _pforw4; //_pforw3[t+1][q][v] P(S_t+1=v, R_t+1=q | X_1^t)

  float*** _pback1; //_pback1[t][q][v]   P(S_t=u, R_t=q | X_1^_lseq)
  float*** _pback2; //_pback2[t+1][q][v] P(S_t+1=v, R_t=q | X_1^_lseq)

  float** _pobs_gaussian; //_pobs_gaussian[t][v] P(x_t|S_t=v, O_t=0)

  //Viterbi
  float*** _vitVval;
  float*** _vitWval;
  int*** _vitVbackM;
  int*** _vitVbackS;
  int*** _vitWbackR;


 public:
  FbVar(Params& par, int windowl); 
  ~FbVar();
};

#endif
